global var = load('input_outlab_task_A2.txt');#reading from input file
global final_co=[0,0];#final co-ordinates X-wing
global final_co;

function ret = eqnset2(i)
  global var;
  global final_co;#intialising variables
  x1 = var(1);
  y1 = var(2);
  v2 = var(3);
  vls = var(4);
  d = var(5);
  w = var(6);
  u = var(7);
  t1 = var(8);  # formula born from physics 
  t2 = (vls * cos(i) / ( vls * cos(i) - v2)) * (((y1 - (w )) /(vls * cos(i))) + (u * u * w /((sqrt(u^2 - sin(i)^2)) * vls )) + (v2 * t1  /(vls * cos(i))));
  y1f = y1+v2*t1+v2*t2;  #updated value of final y co-ordinates of X-wing
  final_co=[x1,y1f];
  ret = ((y1-w -d)*tan(i))+(w*sin(i)/(sqrt(u^2-(sin(i))^2)))  + (y1f - y1 + d)*tan(i) - x1;#final func to solve
endfunction

x0= pi/4;
ret1 = fsolve(@eqnset2,x0);#finding root with x0 as intial value
ret1 = ret1*180/pi;  #angle in radian
fid = fopen('output_outlab_task_A2.txt' ,'w');
fprintf(fid,'%f %f %f',ret1, final_co(1), final_co(2));
fclose(fid);
clear;