var text = document.getElementById("name");
var email = document.getElementById("mail");
var pwd = document.getElementById("pwd");
var errorText = document.getElementById("0");
var errorEmail = document.getElementById("1");
var errorPwd = document.getElementById("2");

function encode(str){
	var str_splitted = str.split('<');
	var ret = str_splitted[0];
	for(k=1;k<str_splitted.length;k++){
		ret+='&lt'+str_splitted[k];
	}
	str_splitted = ret.split('>');
	ret = str_splitted[0];
	for(k=1;k<str_splitted.length;k++){
		ret += '&gt'+str_splitted[k];
	}
	return ret;
}

var checkText = function checkName() {
	var x = document.forms["myForm"]["text"].value;
    //console.log(x);
    if(x.length == 0){
    	errorText.innerHTML = "This field can't be empty";
    }
    else if (x.length<6){
        errorText.innerHTML = "This field must have a length between 6 and 50 characters";
        return false;
    }
}

var checkPwd = function checkPass() {
	var x = document.forms["myForm"]["pass"].value;
    if (x.length == 0) {
    	errorPwd.innerHTML = "This field can't be empty";
    	return false;
    }
    else if(x.length<8){
    	errorPwd.innerHTML = "This field must have a length between 8 and 20 characters";
    	return false;
    }
    else{	
    	var a =false;
    	for(i=0;i<x.length;i++){
    		if((x.charAt(i)=='@'||x.charAt(i)=='_'||x.charAt(i)=='!'||x.charAt(i)=='$')){
    			a=true;
    		}
    	}
    	if(!a){
    		errorPwd.innerHTML = "This field should have at least one of the {@,!,$,_} special characters";
	    	return false;
	    }
    }
}

var checkMail = function checkEmail() {
	var x = document.forms["myForm"]["email"].value;	    
	var arr = x.split('@');
	if(arr.length == 2){
		var local = arr[0];
		var domain = arr[1];
		//checking for the local part
		if(local.length <= 2){
			errorEmail.innerHTML = "Local part should have at least 3 characters";
			return false;
		}
		else{
			for(j=0;j<local.length;j++){
				var x = local;
    			var y = (x.charCodeAt(j)>=48 && x.charCodeAt(j)<=57)
    					||(x.charCodeAt(j)>=65 &&x.charCodeAt(j)<=90)
    						||(x.charCodeAt(j)>=97 &&x.charCodeAt(j)<=122)
    							||(x.charCodeAt(j) == 46 || x.charCodeAt(j)==95);
    			
    			if(!y){
    				errorEmail.innerHTML = "Local part has invalid character";
    				return false;
    			}
    			
			}
		}
		//checking for the domain part
		var domainarr = domain.split('.');
		console.log(domainarr[0]);
		if(domainarr.length < 2){
			errorEmail.innerHTML = "Invalid domain name";
		}
		else if(domainarr[0].length>=3){
			for(k=0;k<domainarr.length;k++){
				for(j=0;j<domainarr[k].length;j++){
					var x = domainarr[k];
					var y = (x.charCodeAt(j)>=65 &&x.charCodeAt(j)<=90)||(x.charCodeAt(j)>=97 &&x.charCodeAt(j)<=122);
					console.log(y);
					if(!y){
						errorEmail.innerHTML = "Domain part is invalid";
						return false;
					}

					
					if(domainarr[k].length<2){

						errorEmail.innerHTML = "Domain part doesn't satisfy the length constraints between two consecutive periods(.)";
						return false;
					}	
				}
			}
		}
		else{
			errorEmail.innerHTML = "Domain part is too short";
		}
	}
	else {
		if(x.length == 0){
			errorEmail.innerHTML = "This field can't be empty";
		}
		else {
			errorEmail.innerHTML = "Please enter a valid e-mail address";
		}
	}
}

function clearError(n) {
	switch (n) {
		case 0 :
			errorText.innerHTML = "";
			break;
		case 1 : 
			errorEmail.innerHTML = "";
			break;
		case 2 :
			errorPwd.innerHTML = "";
			break;
		default :
			break;
	}
}

function checkAllEncode() {
	var b = checkMail() || checkText() || checkPwd();
	text.value = encode(text.value);
	email.value = encode(email.value);
	return b;
}

text.onblur = checkText;
email.onblur = checkMail;
pwd.onblur = checkPwd;


